local nn =require("nn")
local shd = require("shaders")

local ScrW, ScrH = love.graphics.getWidth, love.graphics.getHeight
local physics = love.physics

local color = love.graphics.setColor
local circ = love.graphics.circle
local line = love.graphics.line

local isMDown,isDown = love.mouse.isDown,love.keyboard.isDown

local m1d = false
local m2d = false

local dpx, dpy = 0,0
local drx, dry = 0,0

local sin,cos,atan2,pi = math.sin,math.cos,math.atan2,math.pi
local pi2 = pi/2
local flr = math.floor

math.randomseed(os.time())

local _fill,_line = "fill","line"

function rot(x,y,r)
	return x*cos(r*pi/180),y*sin(r*pi/180)
end

function hsv( h, s, v, a )	--https://github.com/EmmanuelOga/columns/blob/master/utils/color.lua (LICENSE: http://creativecommons.org/licenses/by/3.0/legalcode)
	h=h/360

	local i = flr(h * 6);
	local f = h * 6 - i;
	local p = v * (1 - s);
	local q = v * (1 - f * s);
	local t = v * (1 - (1 - f) * s);

	i = i % 6

	if i == 0 then r, g, b = v, t, p
	elseif i == 1 then r, g, b = q, v, p
	elseif i == 2 then r, g, b = p, v, t
	elseif i == 3 then r, g, b = p, q, v
	elseif i == 4 then r, g, b = t, p, v
	elseif i == 5 then r, g, b = v, p, q
	end
	
	return {r* 255, g* 255, b* 255, (a or 1) * 255}
end

--[[
////////////////////////////////////////
]]


local NX,NY = 3,13  --width, height
local learn_rate = 0.000003
local jitter = learn_rate * 0 --.0042
local randomness = 1

local sta,cra = 200,100

local tnet = nn(NX,NY,2,13,nn.func.sig,nn.func.asig,learn_rate)
--local tnet = nn(NX,NY,2,6,nn.func.sig,nn.func.asig,learn_rate)
tnet:addlayer(12,nn.func.cos,nn.func.sin)
tnet:addlayer(10,nn.func.cos,nn.func.sin)

for i = 1, math.random(3,5) do
	--if math.random(1,5) == 2 then
		tnet:addlayer(13-i,nn.func.cos,nn.func.sin)


	--else
	--	tnet:addlayer(math.random(5,8),nn.func.sig,nn.func.asig)

	--end
	NX = NX+1
end

tnet:addlayer(7,nn.func.sig,nn.func.asig)
tnet:addlayer(1)

NX = NX + 5
NY = 18
--tnet:addlayer(1)
--[[tnet:addlayer(9)
tnet:addlayer(7)
tnet:addlayer(5)
tnet:addlayer(1)]]
--tnet.net[3][1].act = nn.func.sig
--tnet.net[3][1].drv = nn.func.asig
tnet:build()
local batchsize = 24

--[[
////////////////////////////////////////
]]


local train_pairs = {
	{{0,0},{0}},
	{{1,0},{1}},
	{{0,1},{1}},
	{{1,1},{0}},
	--{{1,1},{1}},
	--{{1,0.5},{1}},
	--{{0.31,0.4},{0}},

	--{{1,1},{0,0}},
	--{{1,0},{0,1}},
	--{{0,1},{1,0}},
	--{{0,0},{1,1}},
}

local train_pairs_n = #train_pairs

local runner = 1
local err,err_t = 0,{}

local spa = false
local spl = false
local time  = love.timer.getTime

function love.update(dt)
	if love.keyboard.isDown("space") and not spa then
		spa = time()+0.3
		spl = (not spl)
	elseif love.keyboard.isDown("space") and spa and spa < time() and not spl then
		spl = true
	elseif not love.keyboard.isDown("space") and spa then
		spa = false
		--spl = false
	end

end

local text = love.graphics.print
local text2 = love.graphics.printf

local cnvs = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")
local cnvs2 = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")

local netc = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")
local netcf = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")

local netcs = {}
for I=1,train_pairs_n do
	
	netcs[I]=1

end

local nbx = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")
local nby = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")

local lrp = 0

local gx,gy = ScrW()/(NX),ScrH()/(NY+1)

local tmin, tmax
local wmin, wmax

local time = love.timer.getTime
local lt = time()
local adt = time()

local mom = 0


local avgerr = 0

local frt,frtt = 0,false

function love.draw()
	local mx,my = love.mouse.getPosition()
	local ft = time() - lt
	lt = time()
	--[[color(1,120,255,20)
	for I = 1, 2 do
		local h = ScrH()-(ScrH()*(I/2))/3
		line(0,h,ScrW(),h)
	end]]

	local px,py = 50,50
	if spl or frt < time() then
		frt = time()+0.05
		frtt = true
		local t = time()+0.01
		while (t > time() and spl) or frtt do
			for k,v in pairs(nn.nets) do
				if v.rv then
					if spl then
						love.graphics.setCanvas(cnvs)
							love.graphics.clear(0,0,0,0)
							color(255,255,255,254)
							love.graphics.setBlendMode("alpha")
							love.graphics.draw(cnvs2)

						love.graphics.setCanvas()


					end
				end
			end
			--local sev = 0
			for I = 1 , batchsize+1 do

				local err,err_t,rn = tnet:smart_train(train_pairs,randomness,jitter)

				netcs[rn] = err

				--local rnd = math.random(-math.pi*1000,math.pi*1000)/1000
				--local pair = tnet:pairpicker(train_pairs)
				--local err,err_t = tnet:train(pair)

				--sev = sev + err
				--tnet.lr = 0 --30/(100*err)
				--tnet:pairupdate(pair,err)--last: error jitter

				


				for k,v in pairs(nn.nets) do
					if v.rv then
						if spl or frtt then
							love.graphics.setCanvas(cnvs)
								--color(0,0,0,10)
								--line(runner,0,runner,ScrH())
								local stretch = (ScrH()*v.rv)/3
								local rp = (ScrH()-stretch)/2
								if I > 1 then
									love.graphics.setBlendMode("add")
									color(hsv(0,0,0,0.3))
									--love.graphics.rectangle( "fill", runner,rp-2,2,stretch )
									--line(runner,lrp-2,runner,rp+2)
									----color(hsv(0,0,0,0.1))
									--line(runner-1,lrp-2,runner-1,rp+2)
									love.graphics.setBlendMode("add")
									color(hsv(240-(rn/(train_pairs_n+1))*360,0.5,0.92,(0.05/(stretch/2))^1.2))
									--color(hsv(240-v.rv*360,0.7,1,1/batchsize))
									--love.graphics.rectangle( "fill", runner-1,rp-2,3,3 )
									love.graphics.rectangle( "fill", runner,rp-2,1,stretch )

									color(hsv(240-(rn/(train_pairs_n+1))*360,0.5,0.92,0.02+(0.005/(stretch/2))))

									--color(hsv(240-(rn/(train_pairs_n+1))*360,0.7,1,0.337))
									love.graphics.rectangle( "fill", runner,rp-2,1,3 )
									love.graphics.rectangle( "fill", runner,rp+stretch-5,1,3 )
									--love.graphics.rectangle( "fill", runner-1,rp-1,3,1 )

									----color(hsv(240-(rn/(train_pairs_n+1))*360,0.7,1,1))
									--color(hsv(240-v.rv*360,0.7,1,1))
									--line(runner,lrp,runner,rp)
									--love.graphics.points( runner,rp )
								end
								--color(hsv(v.rv*240,0.6,1,0.5))
								--line(runner-1,lrp,runner,rp)
								lrp = rp
							love.graphics.setCanvas()


						end
					end
				end
			end

			avgerr = 0

			for k,v in ipairs(netcs) do
				avgerr = avgerr + v
			end
			avgerr = avgerr / train_pairs_n
			mom = mom + ((avgerr/3)-mom)*3*ft^2

			if spl or frtt then

				adt = adt + ft*mom

				local stretch = (ScrH()*avgerr)/3+2
				local rp = (ScrH()-stretch)/2

				love.graphics.setCanvas(cnvs)
				love.graphics.setBlendMode("add")

					color(hsv(1,0,1,(0.1/(stretch))))
					love.graphics.rectangle( "fill", runner,rp-2,1,stretch )

					color(hsv(1,0,1,(0.2/(stretch))))

					love.graphics.rectangle( "fill", runner,rp,1,1 )
					love.graphics.rectangle( "fill", runner,rp+stretch-5,1,1 )
				love.graphics.setCanvas()

				--if avgerr < 0.25 then spl = 0 end
			end


			love.graphics.setCanvas(cnvs)
			love.graphics.setBlendMode("alpha")

				--color(255,255,255,20)
				--love.graphics.rectangle( "fill", runner,ScrH()/2-1,1,2 )

			love.graphics.setCanvas()

			love.graphics.setBlendMode("alpha")

			love.graphics.setCanvas(cnvs2)
				love.graphics.clear(0,0,0,255)
				color(255,255,255,255)
				love.graphics.draw(cnvs)
			love.graphics.setCanvas()

			tnet:applybatch()

			runner = runner + 1
			if runner > ScrW() then runner = 1 end
			frtt = false
		end
	end

	
	local sq = 1

	while true do

		if sq^2 > train_pairs_n then break end
		sq=sq+1

	end

	--[[for I=1,train_pairs_n do
		
		local x = ((I-1)%2)
		local y = ((I)%sq)

		love.graphics.draw(netcs[I],x*ScrW()/sq,y*ScrH()/sq,0,1/sq,1/sq)
	end]]

	local times = 0.382
	local phase = (adt+math.sin(time()*0.45)*0.062)*times
	local ph_mul = 4
	local amp = 22

	love.graphics.setCanvas(netc)
	love.graphics.clear()
	love.graphics.setCanvas(netcf)
	love.graphics.clear()
	love.graphics.setCanvas()

	--love.graphics.setBlendMode("add")

	for k,v in pairs(nn.nets) do
		for x,r in ipairs(v.net) do
			for y,n in ipairs(r) do
				local cr = #r
				local mult = cra

				local cos = math.cos((y/cr+phase)*math.pi*2)*((cr-1)/NY)
				local xo, yo = love.math.noise( ((x)/#v.net)*ph_mul+phase, (y/cr)*ph_mul+phase )*amp*cos, love.math.noise( (y/cr)*ph_mul+phase )*amp*cos
				--local xo, yo = math.sin( (((x)/#v.net)*ph_mul+phase)*math.pi/4 )*amp, math.cos( ((y/cr)*ph_mul+phase)*math.pi/2)*amp
				--local xo, yo = math.sin( (((x/#v.net+y)*math.pi/2)*ph_mul+phase) )*amp, math.cos( ((y/cr*math.pi/2)*ph_mul+phase))*amp

				local cx,cy = px+(x-1)*gx+cos*gx/8+xo, (ScrH())/2+math.sin((y/cr+phase)*math.pi*2)*(ScrH()-100)/2*((cr-1)/NY)+yo

				if cos >=0 then 
					love.graphics.setCanvas(netcf)
				else
					love.graphics.setCanvas(netc)
				end
					--love.graphics.clear()

				if x > 1 then
					local cr2 = #v.w[x-1][y]
					local mult2 = cra
					local nnet = v.w[x-1][y]
					for j,cw in ipairs(nnet) do
						if wmin and wmax then mult2 = math.abs(cra/(wmax-wmin)) end

						local cn = #nnet
						local lcos = math.cos((j/cn+phase)*math.pi*2)*((cn-1)/NY)
						local xo2, yo2 = love.math.noise( ((x-1)/#v.net)*ph_mul+phase, (j/cn)*ph_mul+phase )*amp*lcos, love.math.noise( (j/cn)*ph_mul+phase )*amp*lcos
						--local xo2, yo2 = math.sin( (((x-1)/#v.net)*ph_mul+phase)*math.pi/4)*amp, math.cos( ((j/cn)*ph_mul+phasey)*math.pi/2)*amp
						--local xo2, yo2 = math.sin( ((((x-1)/#v.net+j)*math.pi/2)*ph_mul+phase))*amp, math.cos( ((j/cn*math.pi/2)*ph_mul+phasey))*amp
						--local x1,y1,x2,y2 = cx,cy,px+(x-1)*gx-gx+xo2+yo2/3,(ScrH()-cr2*gy)/2+(j-0.5)*gy+yo2

						local x1,y1,x2,y2 = cx, cy, px+(x-2)*gx+lcos*gx/8+xo2, (ScrH())/2+math.sin(((j/cn)+phase)*math.pi*2)*(ScrH()-100)/2*((cn-1)/NY)+yo2
						
						local d = ((x1-x2)^2+(y1-y2)^2)^0.5
						local d2 = ((x1-mx)^2+(y1-my)^2)^0.5
						local d3 = ((x2-mx)^2+(y2-my)^2)^0.5
						--local a = math.min(1,(d2/d)^3)

						if wmin == nil or cw[1] < wmin then wmin = cw[1] end
						if wmax == nil or cw[1] > wmax then wmax = cw[1] end

						if (d-d2-d3)^2 < 0.001 or d2 < 10 or d3 < 10 then
							color(hsv(sta+cw[1]*mult2,1,1,0.8+0.1*(cw[1]/(tmax-tmin))))

							local tx,ty = cx * 0.3 + (cx-gx)*0.7, cy * 0.3 + y2*0.7
							text((flr(cw[1]*v.net[x-1][j][1]*1000)/1000)..">\n".."w["..flr(cw[1]*1000)/1000 .."]".."\n>"..(flr(v.net[x-1][j][1]*1000)/1000),tx,ty,pi+math.atan2(ty-cy,tx-cx),0.8,0.8)
					
						else
							local sca = math.sin((math.abs(cw[1]/(tmax-tmin))^3)*pi/180)
							color(hsv(sta+cw[1]*mult2,0.8-sca*0.1,1,0.03+0.89*sca))

							--local tx,ty = cx * 0.3 + (cx-gx)*0.7, cy * 0.3 + y2*0.7
							--text((flr(cw[1]*v.net[x-1][j][1]*1000)/1000)..">",tx,ty,pi+math.atan2(ty-cy,tx-cx),0.8,0.8)
					
						end

						line(x1,y1,x2,y2)
						end
				end
				local mmu = 1+(cos+1)/2


				if tmin and tmax then
					mult = math.abs(cra/(tmax-tmin))
					color(hsv(sta+n[1]*mult,0.95-(0.12*mmu),1,0.1+0.25*math.abs(n[1]/(tmax-tmin))^2-(0.05*mmu)))
				else
					color(hsv(sta+n[1]*mult,1,1,0.318))
				end

				

				if tmin == nil or n[1] < tmin then tmin = n[1] end
				if tmax == nil or n[1] > tmax then tmax = n[1] end
				
				

				circ(_fill, cx,cy ,(1+math.abs(n[1])*3)*mmu)
				circ(_fill, cx,cy ,(2+math.abs(n[1])*3)*mmu)
				circ(_fill, cx,cy ,(3+math.abs(n[1])*3)*mmu)
				circ(_fill, cx,cy ,(4+math.abs(n[1])*3)*mmu)
				circ(_fill, cx,cy ,(5+math.abs(n[1])*3)*mmu)

				color(hsv(sta+n[1]*mult,0.8-(0.2*mmu),1,0.62-(0.2*mmu)))
				circ(_fill, cx,cy ,1.6*mmu^2)

				if ((cx-mx)^2+(cy-my)^2)^0.5 < 20 then
					local t = (flr(n[1]*1000)/1000) .. " => " ..(flr(n[2]*1000)/1000).."(err:"..(flr(n[3]*1000000)/1000000)..")\nB:"..(flr(r.b*1000)/1000)
					color(0,0,0,240)
					text(t,cx-19,cy-9,-0.15,0.77,0.77,4)
					color(hsv(sta+n[1]*mult,0.3,1,1))
					text(t,cx-20,cy-10,-0.15,0.77,0.77,4)
				end

				
			end
		end--]]

		--[[if v.rv then
			color(0,0,255,255)
			text(v.rv,10,10)

			for ie,e in ipairs(v.rt) do
				text((v.out[ie][1]).." / "..e,30,400+20*ie)
			end
		end]]
	end
	love.graphics.setShader()
	love.graphics.setCanvas()

	love.graphics.setShader()
	love.graphics.setBlendMode("alpha")
	color(255,255,255,255)
	--love.graphics.setShader(shd.dsys)
		--love.graphics.draw(netc)
		--love.graphics.draw(netc)
	--love.graphics.draw(nby)
	color(255,255,255,50)
	--love.graphics.draw(netc)

	
	color(255,255,255,255)
	love.graphics.draw(netc)
	love.graphics.setShader()

	love.graphics.setBlendMode("add")
	
	color(255,255,255,150)
	love.graphics.draw(cnvs,-1,0)
	love.graphics.draw(cnvs,-1,0)

	color(255,255,255,50)
	love.graphics.draw(cnvs,0,1)
	love.graphics.draw(cnvs,0,-1)

	color(255,255,255,255)
	love.graphics.draw(cnvs)
	
	love.graphics.setBlendMode("alpha")

	color(255,255,255,255)
	love.graphics.draw(netcf)


	--sta = sta + 1
	--cra = 120 +180*math.sin(time())
	--cra = 12

end


--[[function love.wheelmoved(x, y) --scroll wheel stuff:
	if isDown("lshift","rshift") then
			if y > 0 then
					gx = math.min(2000000,gx*1000	*1.1) / 1000
			elseif y < 0 then
					gx = math.max(25000,gx*1000	/1.1) / 1000
			end
	elseif isDown("lctrl","rctrl") then
			if y > 0 then
					gy = math.min(2000000,gy*1000	*1.1) / 1000
			elseif y < 0 then
					gy = math.max(25000,gy*1000	/1.1) / 1000
			end
	else
		if y > 0 then
					gx = math.min(2000000,gx*1000	*1.1) / 1000
					gy = math.min(2000000,gy*1000	*1.1) / 1000
			elseif y < 0 then
					gx = math.max(25000,gx*1000	/1.1) / 1000
					gy = math.max(25000,gy*1000	/1.1) / 1000
			end
	end
end--]]