shd = {}

shd.ftb = love.graphics.newShader([[
	//uniform number sy;
	vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords)
	{
		vec4 coladd = texture2D(texture, vec2(vTexCoord.x, vTexCoord.y));
		coladd.w = max(0,min(coladd.w,(1-vTexCoord.y)*(1-vTexCoord.y)));

		return color * coladd;
	}
]])

shd.vel = love.graphics.newShader([[

	vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords)
	{
		//vec4 coladd = color - vec4(0.5,0.5,0,0);


		
		//color = (color + texture2D(texture, vec2(vTexCoord.x, vTexCoord.y)))/2;

		return color;
	}
]])

shd.dff = love.graphics.newShader([[
	uniform number wc;
	uniform number ws;
	uniform number wv;
	uniform number bsx;
	uniform number bsy;
	uniform number p;
	uniform Image velmap;

	float dist = 0.0006;

	float len22(vec4 p){
		return ((p.x+p.y+p.z)/3-0.5)*2;
	}

	vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords)
	{
		vec4 sum = vec4(0.0);
		vec4 pix = texture2D(texture, vec2(vTexCoord.x, vTexCoord.y));

		float len = (1+(pix.x+pix.y+pix.z));
		len = len * len;
		
		float bsxl  = bsx * len;
		float bsyl  = bsy * len;

		float p1 = len22(texture2D(velmap, vec2(vTexCoord.x+dist, vTexCoord.y)));
		float p2 = len22(texture2D(velmap, vec2(vTexCoord.x-dist, vTexCoord.y)));
		float p3 = len22(texture2D(velmap, vec2(vTexCoord.x, vTexCoord.y+dist)));
		float p4 = len22(texture2D(velmap, vec2(vTexCoord.x, vTexCoord.y-dist)));

		float vx = p1-p2;
		float vy = p3-p4;

		//float vx = vel.x;
		//float vy = vel.y;

		float wx  = (wc * -wv) - vx/10;
		float wy  = (ws * -wv) - vy/10;

		sum += texture2D(texture, vec2(vTexCoord.x + bsxl + wx, vTexCoord.y + wy))*0.1667*p;
		sum += texture2D(texture, vec2(vTexCoord.x + bsxl + wx, vTexCoord.y + bsyl + wy))*0.0833*p;
		sum += texture2D(texture, vec2(vTexCoord.x + wx, vTexCoord.y + bsyl + wy))*0.1667*p;
		sum += texture2D(texture, vec2(vTexCoord.x - bsxl + wx, vTexCoord.y + bsyl + wy))*0.0833*p;

		sum += texture2D(texture, vec2(vTexCoord.x - bsxl + wx, vTexCoord.y + wy))*0.1667*p;
		sum += texture2D(texture, vec2(vTexCoord.x - bsxl + wx, vTexCoord.y - bsyl + wy))*0.0833*p;
		sum += texture2D(texture, vec2(vTexCoord.x + wx, vTexCoord.y - bsyl + wy))*0.1667*p;
		sum += texture2D(texture, vec2(vTexCoord.x + bsxl + wx, vTexCoord.y - bsyl + wy))*0.0833*p;


		return sum;
	}
]])

--https://gist.github.com/2bt/3627374
local graphics = love.graphics

dsx = {}
dsy = {}

local setcanvas,draw,clear = love.graphics.setCanvas, love.graphics.draw, love.graphics.clear
local ScrW, ScrH = love.graphics.getWidth, love.graphics.getHeight

local function makestr(d)
	return "$"..tostring(d)
end

local bsx = 0.00025
local bsy = 0.00025

shd.dsxs = love.graphics.newShader([[	//shader from googlz
	vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords)
	{
		vec4 sum = vec4(0.0);
		number blurSize = ]]..bsx..[[;
		sum += texture2D(texture, vec2(vTexCoord.x - 4.0*blurSize, vTexCoord.y)) * 0.05;
		sum += texture2D(texture, vec2(vTexCoord.x - 3.0*blurSize, vTexCoord.y)) * 0.09;
		sum += texture2D(texture, vec2(vTexCoord.x - 2.0*blurSize, vTexCoord.y)) * 0.12;
		sum += texture2D(texture, vec2(vTexCoord.x - blurSize, vTexCoord.y)) * 0.15;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y)) * 0.16;
		sum += texture2D(texture, vec2(vTexCoord.x + blurSize, vTexCoord.y)) * 0.15;
		sum += texture2D(texture, vec2(vTexCoord.x + 2.0*blurSize, vTexCoord.y)) * 0.12;
		sum += texture2D(texture, vec2(vTexCoord.x + 3.0*blurSize, vTexCoord.y)) * 0.09;
		sum += texture2D(texture, vec2(vTexCoord.x + 4.0*blurSize, vTexCoord.y)) * 0.05;
		
		return sum;
	}
	]])

shd.dsys = love.graphics.newShader([[
	vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords)
	{
		vec4 sum = vec4(0.0);
		number blurSize = ]]..bsy..[[;

		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y - 4.0*blurSize)) * 0.05;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y - 3.0*blurSize)) * 0.09;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y - 2.0*blurSize)) * 0.12;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y- blurSize)) * 0.15;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y)) * 0.16;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + blurSize)) * 0.15;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + 2.0*blurSize)) * 0.12;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + 3.0*blurSize)) * 0.09;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + 4.0*blurSize)) * 0.05;

		return sum;
	}
	]])


local push, pop = love.graphics.push, love.graphics.pop
local translate = love.graphics.translate
local circ = love.graphics.circle

function shade(tbl,d,bx,by)
	d = (math.floor(d*100)/40)*3
	local dS = makestr(d)

	local l = math.ceil(tbl.s+d*2)*2
	local l2 = l/2
	tbl.l2 = l
	local bcvx = bx or love.graphics.newCanvas(l,l)
	local bcvy = by or love.graphics.newCanvas(l,l)

	--love.graphics.setColor(255,255,255,120)

	push()
	 translate(l2,l2)
		setcanvas(bcvy)
		clear()
	    --love.graphics.setShader(dsx[dS])
	    --love.graphics.setShader(dsx[dS])

	    love.graphics.setColor(60,60,60,255)
	    circ("fill",0,0,tbl.s,(1+tbl.s)*math.pi*2)
    pop()

    for i = 1, d do
	    setcanvas(bcvx)
		    --love.graphics.setShader(dsy[dS])
		    love.graphics.setShader(shd.dsys)
		    draw(bcvy)
		    love.graphics.setShader()

	    setcanvas(bcvy)
		    --love.graphics.setShader(dsx[dS])
		    love.graphics.setShader(shd.dsxs)
		    draw(bcvx)
		    love.graphics.setShader()
	end
	--love.graphics.setBlendMode("add")
	--    circ("line",0,0,tbl.s,tbl.s*math.pi*2)
	 --   love.graphics.setShader()


    if lcvs then setcanvas(lcvs) else setcanvas() end

    return bcvy
end


return shd